# defaults
set ns_tcp(maxburst) 0
set ns_tcp(maxcwnd) 0
set ns_tcp(window) 20
set ns_tcp(window-init) 1
set ns_tcp(window-option) 1
set ns_tcp(window-constant) 4
set ns_tcp(window-thresh) 0.002
set ns_tcp(overhead) 0
set ns_tcp(ecn) 0
set ns_tcp(packet-size) 1000
set ns_tcp(bug-fix) true
set ns_tcp(tcp-tick) 0.1
set ns_tcpnewreno(changes) 0
set ns_tcpnewreno(ecn-fix) 0
set ns_tcpnewreno_paced(changes) 0
set ns_tcpnewreno_paced(ecn-fix) 0
set ns_tcpnewreno_paced(backoff) 2
set ns_tcpnewreno_paced(linear) 0
set ns_tcpnewreno_paced(bw-alg) 0
set ns_tcpnewreno_paced(bw-alg-plus) 0
set ns_tcpnewreno_paced(bw-percent) 0.1
set ns_tcpnewreno_paced(timer-interval) 20ms
set ns_tcpnewreno_bw(changes) 0
set ns_tcpnewreno_bw(ecn-fix) 0
set ns_tcpnewreno_bw(bwthresh-percent) 1.0
set ns_tcpnewreno_bw(bw-percent) 0.1
set ns_tcpnewreno_compat(changes) 0
set ns_tcpnewreno_compat(ecn-fix) 0
set ns_tcp_newreno_police(lbrate) 1.0Mb
set ns_tcp_newreno_police(lbdepth) 40ms
set ns_tcp_newreno_police(timer-interval) 20ms
set ns_tcp_sack1_police(lbrate) 1.0Mb
set ns_tcp_sack1_police(lbdepth) 40ms
set ns_tcp_sack1_police(timer-interval) 20ms
set ns_tcp_malicious(window-factor) 0.9
set ns_tcp_sack1_malicious(window-factor) 0.9
set ns_tcp_fack_malicious(window-factor) 0.9
set ns_tcp_newreno_priority(target-bw) 2.0Mb
set ns_tcp_newreno_priority(algorithm) 0
set ns_tcp_newreno_priority(weight) 0.01
set ns_tcp_newreno_priority(increment) 0.10
set ns_tcp_newreno_priority(bwcheck-interval) 20ms
set ns_tcp_newreno_priority(probe-interval) 500ms
set ns_tcp_newreno_priority(probe-max) 128
set ns_tcp_newreno_priority(changes) 0
set ns_tcp_newreno_priority(history) 1
set ns_tcp_newreno_priority(bins) 1024
set ns_tcp_sack1_priority(target-bw) 2.0Mb
set ns_tcp_sack1_priority(algorithm) 0
set ns_tcp_sack1_priority(weight) 0.01
set ns_tcp_sack1_priority(bwcheck-interval) 50ms
set ns_rclass(weight) 0.01
set ns_rclass(target-bw) 0Mb
set ns_rclass(update-interval) 50ms

# These parameters have all been verified: window, window-init,
#   packet-size, bug-fix (tcp, tcp-reno), overhead (tcp but not tcp-reno), 
#   ecn (tcp, tcp-reno, tcp-sink, and tcp-sink-da).  
#   The "overhead" option has not been implemented for tcp-reno.
# The following parameters are for obscure options probably only of interest 
#  to Sally, and have not been tested in the new simulator: window-option, 
#  window-constant, window-thresh.

set ns_red(bytes) false
set ns_red(thresh) 5
set ns_red(maxthresh) 15
set ns_red(mean_pktsize) 500
set ns_red(q_weight) 0.002
set ns_red(wait) true
set ns_red(linterm) 50
set ns_red(setbit) false
set ns_red(drop-tail) false
set ns_red(doubleq) false
set ns_red(dqthresh) 50
set ns_red(subclasses) 1
# These parameters have all been verified: thresh, maxthresh, q_weight,
#  linterm, setbit.
# These parameters are for obscure options probably only of interest to
#  Sally, and have not been tested in the new simulator: doubleq, dqthresh.
# These parameters have not been tested: bytes, mean_pktsize, wait, drop-tail.

# These parameters below are only used for RED queues with RED subclasses.
#set ns_red(thresh1) 5
#set ns_red(maxthresh1) 15
#set ns_red(mean_pktsize1) 500
set ns_dred(alpha) 2
set ns_dred(beta) 2
set ns_redcop(pthresh) 80
set ns_redcop(pmaxthresh) 100
set ns_fredcop(pthresh) 80
set ns_fredcop(pmaxthresh) 100
set ns_fredcop(rlimit-thresh) 5
set ns_fredcop(strike-thresh) 10
set ns_redp(bias) 100
set ns_cbredp(target-bw) 0Mbs
set ns_cbredp(weight) 0.001
set ns_cbredcop(target-bw) 0Mbs
set ns_cbredcop(weight) 0.001

set ns_cbq(algorithm) 0
set ns_cbq(max-pktsize) 1024
set ns_class(priority) 0
set ns_class(depth) 0
set ns_class(allotment) 0.0
set ns_class(maxidle) 4ms
set ns_class(minidle) -0.2ms
set ns_class(extradelay) 0
set ns_class(plot) false
set ns_class(qdisc) red
#set ns_class(qdisc) drop-tail
#set ns_class(qdisc) redcop
#set ns_class(qdisc) redp
# These parameters have all been verified: priority, depth, allotment,
#  maxidle, minidle, extradelay.

set ns_sink(packet-size) 40
set ns_delsink(interval) 100ms
set ns_sacksink(max-sack-blocks) 3
set ns_cbr(interval) 3.75ms
set ns_cbr(random) 0
set ns_cbr(packet-size) 210
set ns_rlm(interval) 3.75ms
set ns_rlm(packet-size) 210

set ns_ivs(S) 1
set ns_ivs(R) 1
set ns_ivs(state) 0
set ns_ivs(rttShift) 0
set ns_ivs(keyShift) 0
set ns_ivs(key) 0
set ns_ivs(maxrtt) 0.0
set ns_ivs(ignoreR) 0

set ns_source(maxpkts) 0
set ns_telnet(interval) 1000ms
set ns_bursty(interval) 0
set ns_bursty(burst-size) 2
set ns_cbr(interval) 3.75ms
set ns_cbr(random) 0
set ns_cbr(packets) 210
set ns_message(packet-size) 40

set ns_facktcp(ss-div4) 1
set ns_facktcp(rampdown) 1

set ns_link(bandwidth) 1.5Mb
set ns_link(delay) 100ms
set ns_link(queue-limit) 50
set ns_lossy_uniform(loss_prob) 0.00
# These packets have all been verified: link(bandwidth), link(delay),
#  link(queue-limit), telnet(interval), delsink(interval).

set ns_queue(size) 50
#  Is queue(size) used anywhere?

proc ns_connect { src sink } {
	$src connect [$sink addr] [$sink port]
	$sink connect [$src addr] [$src port]
}

proc ns_duplex { n1 n2 bw delay type } {
	set link0 [ns link $n1 $n2 $type]
	$link0 set bandwidth $bw
	$link0 set delay $delay
	set link1 [ns link $n2 $n1 $type]
	$link1 set bandwidth $bw
	$link1 set delay $delay
	return "$link0 $link1"
}

#
# Create a source/sink connection pair and return the source agent.
# 
proc ns_create_connection { srcType srcNode sinkType sinkNode class } {
	set src [ns agent $srcType $srcNode]
	set sink [ns agent $sinkType $sinkNode]
	$src set class $class
	$sink set class $class
	ns_connect $src $sink
	return $src
}

#
# Create a source/sink connection pair and return the source agent.
# 
proc ns_create_connection_logsink { srcType srcNode sinkType sinkNode class logFile} {
	set src [ns agent $srcType $srcNode]
	set sink [ns agent $sinkType $sinkNode]
	set trace [ns trace]
	$trace attach [open $logFile w]
	$sink trace $trace
	$src set class $class
	$sink set class $class
	ns_connect $src $sink
	return $src
}

#
# Create a Reno TCP connection with the source/sink pair.  
#   Maximum window $window, start time $start, class $class.
#
proc ns_create_reno { tcpSrc tcpDst window start class} {
        set tcp [ns_create_connection tcp-reno $tcpSrc tcp-sink $tcpDst $class]
        $tcp set window $window
        set ftp [$tcp source ftp]
        ns at $start "$ftp start"
	return $tcp
}

#
# Create a NewReno TCP connection with the source/sink pair.  
#   Maximum window $window, start time $start, class $class.
#
proc ns_create_newreno { tcpSrc tcpDst window start class} {
        set tcp [ns_create_connection tcp-newreno $tcpSrc tcp-sink $tcpDst $class]
        $tcp set window $window
        set ftp [$tcp source ftp]
        ns at $start "$ftp start"
	return $tcp
}

#
# Create a NewReno TCP connection with the source/sink pair.  
#   Maximum window $window, start time $start, class $class.
#
proc ns_create_newreno_logsink { tcpSrc tcpDst window start class logFile} {
        set tcp [ns_create_connection_logsink tcp-newreno $tcpSrc tcp-sink $tcpDst $class $logFile]
        $tcp set window $window
        set ftp [$tcp source ftp]
        ns at $start "$ftp start"
	return $tcp
}

#
# Create a Sack1 TCP connection with the source/sink pair.  
#   Maximum window $window, start time $start, class $class.
#
proc ns_create_sack1 { tcpSrc tcpDst window start class} {
        set tcp [ns_create_connection tcp-sack1 $tcpSrc sack1-tcp-sink $tcpDst $class]
        $tcp set window $window
        set ftp [$tcp source ftp]
        ns at $start "$ftp start"
	return $tcp
}

proc ns_create_nr_cload { tcpSrc tcpDst tcpType window rate tdepth burst start class} {
	set tcp [ns_create_connection $tcpType $tcpSrc tcp-sink $tcpDst $class]
	$tcp set window $window
	$tcp set lbrate $rate
	$tcp set lbdepth $tdepth
	if {$burst != 0} {
		$tcp set maxburst $burst
	}
	set ftp [$tcp source ftp]
	ns at $start "$ftp start"
	return $tcp
}

proc ns_create_nr_priority { tcpSrc tcpDst tcpType window rate burst start class} {
	set tcp [ns_create_connection $tcpType $tcpSrc tcp-sink $tcpDst $class]
	$tcp set window $window
	$tcp set target-bw $rate
	if {$burst != 0} {
		$tcp set maxburst $burst
	}
	set ftp [$tcp source ftp]
	ns at $start "$ftp start"
	return $tcp
}

proc ns_create_sa_priority { tcpSrc tcpDst tcpType window rate burst start class} {
	set tcp [ns_create_connection $tcpType $tcpSrc sack1-tcp-sink $tcpDst $class]
	$tcp set window $window
	$tcp set target-bw $rate
	if {$burst != 0} {
		$tcp set maxburst $burst
	}
	set ftp [$tcp source ftp]
	ns at $start "$ftp start"
	return $tcp
}

proc ns_create_sa_cload { tcpSrc tcpDst tcpType window rate tdepth burst start class} {
	set tcp [ns_create_connection $tcpType $tcpSrc sack1-tcp-sink $tcpDst $class]
	$tcp set window $window
	$tcp set lbrate $rate
	$tcp set lbdepth $tdepth
	if {$burst != 0} {
		$tcp set maxburst $burst
	}
	set ftp [$tcp source ftp]
	ns at $start "$ftp start"
	return $tcp
}

#
# Create a source/sink connection pair for a CBR connection, and return
#   the source agent.
#
proc ns_create_cbr { srcNode sinkNode pktSize interval class } {
	set src [ns agent cbr $srcNode]
	set sink [ns agent loss-monitor $sinkNode]
        $src set interval $interval
        $src set packet-size $pktSize
        $src set class $class
        ns_connect $src $sink
	return $src
}

#
# Procedure for backward compatibility with old ns commands.
# Preferred approach is to allocate objects with the "new" command.
#
proc ns { cmd args } {
	global ns_compat
	if { $cmd == "node" } {
		if ![info exists ns_compat(route-logic)] {
			set ns_compat(route-logic) [new route-logic]
		}
		set node [new node]
		$ns_compat(route-logic) insert $node
		return $node
	}
	if { $cmd == "link" } {
		if { [llength $args] == 3 } {
			set src [lindex $args 0]
			set dst [lindex $args 1]
			set type [lindex $args 2]
			set L [new link $type]
			$L install $src $dst
			set ns_compat(link:$src:$dst) $L
			return $L
		}
		if { [llength $args] == 2 } {
			set src [lindex $args 0]
			set dst [lindex $args 1]
			return $ns_compat(link:$src:$dst)
		}
		if { $args == "" } {
			set L ""
			foreach v [array names ns_compat] {
				if [string match link:* $v] {
					lappend L $ns_compat($v)
				}
			}
			return $L
		}
	}
	if { $cmd == "agent" } {
		if { [llength $args] == 2 } {
			set type [lindex $args 0]
			set node [lindex $args 1]
			set agent [new agent $type]
			$agent node $node
			return $agent
		}
	}
	if { $cmd == "trace" } {
		set trace [new trace]
		return $trace
	}
	if { $cmd == "at" } {
		eval ns-at $args
		return
	}
	if { $cmd == "now" } {
		return [ns-now]
	}
	if { $cmd == "random" } {
		return [eval ns-random $args]
	}
	if { $cmd == "run" } {
		$ns_compat(route-logic) compute-routes
		ns-run
		return
	}
	puts stderr "ns: backward compat doesn't handle 'ns $cmd $args'"
	exit 1
}

#
# XXX hack: the Tcl class calls "tkerror" when it hits an
# error evaluating a tcl stub (e.g., from an ns-at command).
# Dump a stack trace and exit.
# 
proc tkerror s {
	global errorInfo
	puts stderr "ns: tcl eval error"
	puts stderr $errorInfo
	exit 1
}

##########################################################################
# CBQ									 #
##########################################################################

#
# Create a CBQ (class-based queueing) class with the specified parameters.
#	use ns_class(qdisc) as the default
#
proc ns_create_class { parent borrow allot maxIdle minIdle priority depth extraDelay} { 
	global ns_class ns_link
        set class [new class]
        set class1 [ns_class_params $class $parent $borrow $allot $maxIdle \
	  $minIdle $priority $depth $extraDelay 0]
	set qdisc [new link $ns_class(qdisc)]
	$class1 qdisc $qdisc
        return $class1 
}

# "Mbps" gives the link bandwidth in Mbps.
proc ns_create_class1 { parent borrow allot maxIdle minIdle priority depth extraDelay Mbps} {
	global ns_class ns_link
        set class [new class]
        set class1 [ns_class_params $class $parent $borrow $allot $maxIdle \
           $minIdle $priority $depth $extraDelay $Mbps]
	set qdisc [new link $ns_class(qdisc)]
	$class1 qdisc $qdisc
        return $class1
}  

proc ns_create_rclass {target weight} {
    set rclass [new rclass]
    $rclass set target-bw $target
    $rclass set weight $weight
    return $rclass
}

#
# Assign the following parameters to the CBQ class.
#
proc ns_class_params { class parent borrow allot maxIdle minIdle priority depth extraDelay Mbps} {  
        $class parent $parent
        $class borrow $borrow
        $class set allotment $allot
        $class set maxidle $maxIdle
        $class set minidle $minIdle
        $class set priority $priority
        $class set depth $depth
        $class set extradelay $extraDelay
        set class1 [ns_class_maxIdle $class $allot $maxIdle $priority $Mbps]
        set class2 [ns_class_minIdle $class $allot $minIdle $Mbps]
        return $class2  
}

#
# If $maxIdle is "auto", set maxIdle to Max[t(1/p-1)(1-g^n)/g^n, t(1-g)].
# For p = allotment, t = packet transmission time, g = weight for EWMA.
#
proc ns_class_maxIdle { class allot maxIdle priority Mbps } {
        if { $maxIdle == "auto" } {
		set g 0.9375
		set n [expr 8 * $priority]
		set gTOn [expr pow($g, $n)]
		set first [expr ((1/$allot) - 1) * (1-$gTOn) / $gTOn ]
		set second [expr (1 - $g)]
		set t [expr (1000 * 8)/($Mbps * 1000000) ]
		if { $first > $second } {
		  	$class set maxidle [expr $t * $first]
		} else {
			$class set maxidle [expr $t * $second]
		}
	} else {
		$class set maxidle $maxIdle
	}
	return $class
}

#
# If $minIdle is "auto", set minIdle to t(1/p-1).
# For p = allotment, t = packet transmission time.
#
proc ns_class_minIdle { class allot minIdle Mbps } {
	if { $minIdle == "auto" } {
		set t [expr -(8000 * 8)/($Mbps * 1000000) ]
		$class set minidle [expr $t / $allot]
	} else {
		$class set minidle $minIdle
	}
	return $class
}

proc ns_dump_tcp { number src interval last_tot} {
	set pktsize [$src get packet-size]
	set total [$src get ack]
	set tot_diff [expr $total - $last_tot]
	set tot_bw [expr $tot_diff * $pktsize * 8.0/($interval*1000000.0)]
	set timeout [$src get timeouts]
	ns at [expr [ns now] + $interval] "ns_dump_tcp $number $src $interval $total"
	puts "[ns now] $number $tot_bw 0 0 $timeout"
}

proc ns_dump_tcp_cload { number src interval last_cmp last_tot last_waste} {
	set pktsize [$src get packet-size]
	set cmp [$src get compliant]
	set total [$src get ack]
	set waste [$src get tokens-wasted]
	set cmp_diff [expr $cmp - $last_cmp]
	set tot_diff [expr $total - $last_tot]
	set was_diff [expr $waste - $last_waste]
	set cmp_bw [expr $cmp_diff * $pktsize * 8.0/($interval*1000000.0)]
	set tot_bw [expr $tot_diff * $pktsize * 8.0/($interval*1000000.0)]
	set was_bw [expr $was_diff * 8.0/($interval*1000000.0)]
	set timeout [$src get timeouts]
	ns at [expr [ns now] + $interval] "ns_dump_tcp_cload $number $src $interval $cmp $total $waste"
	puts "[ns now] $number $tot_bw $cmp_bw $was_bw $timeout"
}

proc ns_dump_tcp_priority { number src interval last_mark last_tot} {
	set pktsize [$src get packet-size]
	set mark [$src get marked]
	set total [$src get ack]
	set cwnd [$src get cwnd]
	set prob [$src get probability]
	set sbwa [$src get sbwa]
	set mark_diff [expr $mark - $last_mark]
	set tot_diff [expr $total - $last_tot]
	set mark_bw [expr $mark_diff * $pktsize * 8.0/($interval*1000000.0)]
	set tot_bw [expr $tot_diff * $pktsize * 8.0/($interval*1000000.0)]
	set timeout [$src get timeouts]
	ns at [expr [ns now] + $interval] "ns_dump_tcp_priority $number $src $interval $mark $total"
	puts "[ns now] $number $tot_bw $mark_bw [expr $tot_bw - $mark_bw] $timeout"
}

proc ns_dump_class { number class interval last_mark last_unmark} {
	set pktsize [$class get packet-size]
	set mark [$class get marked]
	set unmark [$class get unmarked]
	set mark_diff [expr $mark - $last_mark]
	set unmark_diff [expr $unmark - $last_unmark]
	set mark_bw [expr $mark_diff * $pktsize * 8.0/($interval*1000000.0)]
	set unmark_bw [expr $unmark_diff * $pktsize * 8.0/($interval*1000000.0)]
	ns at [expr [ns now] + $interval] "ns_dump_class $number $class $interval $mark $unmark"
    puts "[ns now] $number [expr $unmark_bw + $mark_bw] $mark_bw $unmark_bw"
}
