//  Definition of the scoreboard class:

#define SBSIZE 1024
#define PSBSIZE 1024

class ScoreBoard {
  public:
	ScoreBoard() {first_=0; length_=0;}
	int IsEmpty () {return (length_ == 0);}
	void ClearScoreBoard (); 
	int GetNextRetran ();
	void MarkRetran (int retran_seqno);
	void MarkRetran (int retran_seqno, int snd_nxt);
	int UpdateScoreBoard (int last_ack_, Packet *pkt);
	int CheckSndNxt (Packet *pkt);
	
  protected:
        int first_, length_;
        struct ScoreBoardNode {
		int seq_no_;		/* Packet number */
		int ack_flag_;		/* Acked by cumulative ACK */
		int sack_flag_;		/* Acked by SACK block */
		int retran_;		/* Packet retransmitted */
	        int snd_nxt_;		/* snd_nxt at time of retransmission */
	} SBN[SBSIZE+1];
};

class PriorityScoreBoard {
  public:
	PriorityScoreBoard() {first_=0; length_=0;}
	void LogPacket(int seqno, int priority);
	int StatPacket(int seqno);
  protected:
	int first_, length_;
	struct PriorityScoreBoardNode {
		int seqno_;
		int priority_;
	} PSBN[PSBSIZE+1];
};
